//===========================================================================
// t@C : DateSeal.cs
// @  \   : tf[^@\
//
//   
// +-------------------------------------------------------------------------
// | t          e
// +------------+------------------------------------------------------------
// | 2006/09/30   VK쐬
//===========================================================================
using System;
using System.Drawing;

namespace Hanko {
	/// <summary>
	/// tNX(DateSeal) ̊Tv̐łB
	/// tNX͓tǗf[^NXłB
	/// </summary>
	public class DateSeal {

		#region oϐ
		
		/// <summary>
		/// `TCY(a)
		/// </summary>
		private int m_iDrawDiameter = 50;
		/// <summary>
		/// rbg}bvTCY(a)
		/// </summary>
		private int m_iBmpDiameter = 50;
		/// <summary>
		/// rbg}bv
		/// </summary>
		public Bitmap m_datBmp = null;
		/// <summary>
		/// OtBNX
		/// </summary>
		public Graphics m_datGraphics = null;
		/// <summary>
		/// 摜f[^gktO
		/// </summary>
		private bool m_bStretchImageFlag = false;
		/// <summary>
		/// 摜f[^r[\tO
		/// </summary>
		private bool m_bStretchImageVisibleFlag = true;
		/// <summary>
		/// t
		/// </summary>
		public string m_strDateTime ;

		/// <summary>
		/// ̗ptHg
		/// </summary>
		public Font m_datAppelFont = new System.Drawing.Font("MSSVbN",8) ;
		/// <summary>
		/// ̗ptHg
		/// </summary>
		public string m_datAppelFontName = "MSSVbN";
		/// <summary>
		/// ̗ptHgTCY
		/// </summary>
		public float m_fAppelFontSize = 8;
		/// <summary>
		/// ̗ptHg
		/// </summary>
		public bool m_bAppelFontBold = false;
		/// <summary>
		/// ̗ptHgΑ
		/// </summary>
		public bool m_bAppelFontItalic = false;
		/// <summary>
		/// ̗ptHgTCYtO
		/// </summary>
		public bool m_bAppelFontSizeAutoFlag = true;

		/// <summary>
		/// tptHg
		/// </summary>
		public Font m_datDateFont = new System.Drawing.Font("MSSVbN",8) ;
		/// <summary>
		/// tptHg
		/// </summary>
		public string m_datDateFontName = "MSSVbN";
		/// <summary>
		/// tptHgTCY
		/// </summary>
		public float m_fDateFontSize = 8;
		/// <summary>
		/// tptHg
		/// </summary>
		public bool m_bDateFontBold = false;
		/// <summary>
		/// tptHgΑ
		/// </summary>
		public bool m_bDateFontItalic = false;
		/// <summary>
		/// tptHgTCYtO
		/// </summary>
		public bool m_bDateFontSizeAutoFlag = true;

		/// <summary>
		/// ^eAŘ񋓑
		/// </summary>
		public enum EnumDirection {
			/// <summary>
			/// c
			/// </summary>
			eVert,
			/// <summary>
			/// 
			/// </summary>
			eHorz,
		}
		/// <summary>
		/// ̃^eAR
		/// </summary>
		public EnumDirection m_eAppelDirection = EnumDirection.eHorz;

		/// <summary>
		/// `F
		/// </summary>
		public Color m_datDrawColor = System.Drawing.Color.Red;
		/// <summary>
		/// wiF
		/// </summary>
		public Color m_datBackColor = System.Drawing.Color.White;

		/// <summary>
		/// `
		/// </summary>
		public int m_iLineThickness = 1;
		/// <summary>
		/// R̍ʒu␳l
		/// </summary>
		public int m_iLinePosCorrection = 0;

		/// <summary>
		/// `敶ij
		/// </summary>
		private string m_strAppelTop="c";
		/// <summary>
		/// `敶ij
		/// </summary>
		private string m_strAppelBottom="";

		#endregion oϐ

		#region RXgN^
		/// <summary>
		/// RXgN^
		/// </summary>
		public DateSeal() {
			// 
			this.Initialize();
		}
		#endregion RXgN^

		#region  - Initialize
		/// <summary>
		/// 
		/// </summary>
		public void Initialize() {

			// ----teLXgXV---

			//̓t擾
			DateTime datDateTime = DateTime.Now;	// t (DateTime͒l^)

			// tYY.MM.DD`ɕϊ
			int iYear = datDateTime.Year%100;
			this.m_strDateTime = string.Format("{0,2:D2}.{1,2:D2}.{2,2:D2}",
				iYear, datDateTime.Month, datDateTime.Day);
			
			// 摜XV
			this.UpdateImage();
			
		}
		#endregion  - Initialize


		#region yvpeBz `撼a
		/// <summary>
		/// yvpeBz `撼a
		/// </summary>
		public int ptyDrawDiameter {
			get	{
				// oϐu`TCYv̂܂ܕԂB
				return this.m_iDrawDiameter;
			}
			set {
				// oϐu`TCYvɐݒ肷
				this.m_iDrawDiameter = value;
				// 摜f[^u\ȂvȂ
				if (this.m_bStretchImageFlag==false) {
					// 摜TCYɂf
					this.m_iBmpDiameter = value;
				}
			}
		}
		#endregion yvpeBz `撼a

		#region yvpeBz rbg}bva
		/// <summary>
		/// yvpeBz rbg}bva
		/// </summary>
		public int ptyBmpDiameter {
			// 摜TCYô܂ܕԂ
			get {
				// oϐu摜TCYv̂܂ܕԂ
				return this.m_iBmpDiameter;
			}
			set {
				// oϐu摜TCYvɐݒ肷
				this.m_iBmpDiameter = value;
				// 摜f[^u\ȂvȂ
				if (this.m_bStretchImageFlag==false) {
					// `TCYɂf
					this.m_iDrawDiameter = value;
				}
			}
		}
		#endregion yvpeBz rbg}bva

		#region yvpeBz ̂̏̕(`p)
		/// <summary>
		/// yvpeBz ̂̏̕(`p)
		/// ̂̏̕(`p)擾܂B
		/// </summary>
		public string ptyAppelTopForDraw {
			get {
				// cwȂ
				if (this.m_eAppelDirection==EnumDirection.eVert) {
					//1ƂɉsĕԂ
					return this.ConvertVert(this.m_strAppelTop);
				}
				// wȂ炻̂܂ܕԂ
				return this.m_strAppelTop;
			}
		}
		#endregion yvpeBz ̂̏̕(`p)

		#region yvpeBz ̂̏̕(Rg[p)
		/// <summary>
		/// yvpeBz ̂̏̕(Rg[p)
		/// </summary>
		public string ptyAppelTopForControl {
			get	{
				// oϐu`敶ijv̂܂ܕԂB
				return this.m_strAppelTop;
			}
			set {
				// oϐu`敶ijvɂ̂܂ܐݒ肷B
				this.m_strAppelTop = value;
			}
		}
		#endregion yvpeBz ̂̏̕(Rg[p)

		#region yvpeBz ̂̉̕(`p)
		/// <summary>
		/// yvpeBz ̂̉̕(`p)
		/// ̂̉̕(`p)擾܂B
		/// </summary>
		public string ptyAppelBottomForDraw {
			get {
				// cwȂ
				if (this.m_eAppelDirection==EnumDirection.eVert) {
					//1ƂɉsĕԂ
					return this.ConvertVert(this.m_strAppelBottom);
				}
				// wȂ炻̂܂ܕԂ
				return this.m_strAppelBottom;
			}
		}
		#endregion yvpeBz ̂̉̕(`p)

		#region yvpeBz ̂̉̕(Rg[p)
		/// <summary>
		/// yvpeBz ̂̉̕(Rg[p)
		/// </summary>
		public string ptyAppelBottomForControl {
			get	{
				// oϐu`敶ijv̂܂ܕԂB
				return this.m_strAppelBottom;
			}
			set {
				// oϐu`敶ijvɂ̂܂ܐݒ肷B
				this.m_strAppelBottom = value;
			}
		}
		#endregion yvpeBz ̂̉̕(Rg[p)


		#region yvpeBz 摜f[^gktO
		/// <summary>
		/// yvpeBz 摜f[^gktO
		/// </summary>
		public bool ptyStretchImageFlag {
			get {
				// oϐu摜f[^gktOvԂB
				return this.m_bStretchImageFlag;
			}
			set {
				// oϐu摜f[^gktOvɐݒ肷B
				this.m_bStretchImageFlag = value;
				// 摜f[^gktOuȂvɕύXꂽ
				if (this.m_bStretchImageFlag==false) {
					// u摜TCYv=u`TCYv
					this.m_iBmpDiameter = this.m_iDrawDiameter;
				}
			}
		}
		#endregion yvpeBz 摜f[^

		#region yvpeBz 摜f[^r[\tO
		/// <summary>
		/// yvpeBz 摜f[^r[\tO
		/// </summary>
		public bool ptyStretchImageVisibleFlag {
			get {
				// 摜f[^gktOugkvȂ
				if (this.m_bStretchImageFlag==true){
					// oϐu摜f[^r[\tOvԂ
					return this.m_bStretchImageVisibleFlag;
				}
				// 摜f[^gktOuȂvȂ
				else {
					// u\ȂvԂ
					return false;
				}
			}
			set	{ this.m_bStretchImageVisibleFlag = value; }
		}
		#endregion yvpeBz 摜f[^r[\tO

		#region yvpeBz 摜f[^r[\tO(Rg[p)
		/// <summary>
		/// yvpeBz 摜f[^r[\tO(Rg[p)
		/// </summary>
		public bool ptyStretchImageVisibleFlagForControl {
			get	{ return this.m_bStretchImageVisibleFlag; }
			set	{ this.m_bStretchImageVisibleFlag = value; }
		}
		#endregion yvpeBz 摜f[^r[\tO(Rg[p)

		#region yWbNz ^eɂ
		/// <summary>
		/// yWbNz ^eɂ
		/// </summary>
		/// <param name="strSrc">ϊ</param>
		/// <returns>ϊꂽ</returns>
		private string ConvertVert(string strSrc) {
			// ȂÂ܂܋Ԃ
			if (strSrc==string.Empty) return string.Empty;

			// ԂlpStringBuilder
			System.Text.StringBuilder strRes = new System.Text.StringBuilder();

			// PsR[htiŌ̂P̑O܂Łj
			int i, len = strSrc.Length -1;
			// [vi1sj
			for(i=0;i<len;i++) {
				strRes.Append(strSrc[i]);	// 1
				strRes.Append("\n");		// s
			}
			// Ō̂PiŌ̂P͉sR[hȂj
			strRes.Append(strSrc[len]);

			// string^ɂĕԂB
			return strRes.ToString();
		}
		#endregion ^eɂ

		#region yWbNz 摜XV - UpdateImage
		/// <summary>
		/// 摜XV
		/// </summary>
		public void UpdateImage() {

			// ttHgTCYvZ
			// iTCYtÔƂ̂ݏsj
			this.CalcDateFontSizeAuto();

			// ̕`sȂ̃tO
			bool bUseLine = (this.m_iLineThickness>0)? true : false;

			// y
			Pen ctrPen = new Pen(this.m_datDrawColor, this.m_iLineThickness);
			// uV
			SolidBrush ctrBrush = new System.Drawing.SolidBrush(this.m_datDrawColor);

			// a擾
			int iRadius = this.m_iBmpDiameter/2;


			// ===================
			// a rbg}bv  a
			// ===================

			// rbg}bvCX^X`FbN
			if (
				// rbg}bvĂȂȂ
				this.m_datBmp == null
				// rbg}bvTCY`FbNăTCYύXĂ
				|| this.m_iBmpDiameter!=this.m_datBmp.Width
				|| this.m_iBmpDiameter!=this.m_datBmp.Height
				) {
					// 摜TCY0ȉȂ
					if (this.ptyBmpDiameter<=0) {
						// rbg}bvjďI
						this.m_datBmp = null;
						return;
					}

				// rbg}bv
				this.m_datBmp = new System.Drawing.Bitmap(this.m_iBmpDiameter, this.m_iBmpDiameter);
				// OtBNX(HDC)
				this.m_datGraphics = System.Drawing.Graphics.FromImage(this.m_datBmp);
			}

			// ===================
			// a     wi̕`    a
			// ===================

			// wihԂ
			this.m_datGraphics.Clear(this.m_datBackColor);

			// A`FƔwiFȂ
			if (this.m_datBackColor == this.m_datDrawColor) {
				// hԂiKŏI
				return;
			}

			// ===================
			// a      ~̕`     a
			// ===================

			// ̕`悠
			if (bUseLine) {
				// ̑El𒴂Ƃ
				//  (̑a𒴂ƕ`挋ʂҒʂɂȂȂ
				//   ̑a𒴂Ƃ́Ȃ==a(~hԂ)Ƃ)
				if (this.m_iLineThickness>(this.m_iBmpDiameter/2)) {
					// [̑==a] ̃y
					Pen ctrPenTemp = new Pen(this.m_datDrawColor, iRadius);
					// ~̕`(~hԂ)
					this.m_datGraphics.DrawEllipse(ctrPenTemp, iRadius/2, iRadius/2,
						this.m_iBmpDiameter - iRadius, this.m_iBmpDiameter - iRadius);

					return;
				}

				// ~̕`
				this.m_datGraphics.DrawEllipse(ctrPen, this.m_iLineThickness/2, this.m_iLineThickness/2,
					this.m_iBmpDiameter - this.m_iLineThickness, this.m_iBmpDiameter - this.m_iLineThickness);
			}



			// ===================
			// a     t̕`    a
			// ===================

			// t`TCYil 0,0j
			System.Drawing.SizeF sizeStrDate = new SizeF(0,0);

			// ttHgƂ̂
			if (this.m_datDateFont != null) {
				// Zbg
				string strDate = (this.m_strDateTime!=string.Empty)? m_strDateTime : " " ;

				// ======ʒu擾======

				// `TCY擾
				sizeStrDate = this.m_datGraphics.MeasureString(strDate, this.m_datDateFont);

				// `ʒu YW擾  (a - 񍂂)/2  c`W
				int iStrDate_DrawY = (this.m_iBmpDiameter - (int)sizeStrDate.Height)/2;

				// `ʒu XW擾 [낦]  (a - 񉡕)/2  c`W
				int iStrDate_DrawX = (this.m_iBmpDiameter - (int)sizeStrDate.Width)/2;

				// ======`s======

				// `
				this.m_datGraphics.DrawString(strDate, this.m_datDateFont, ctrBrush, iStrDate_DrawX, iStrDate_DrawY);
			}

			// ===================
			// a  ؂̕`   a
			// ===================

			// ---ʒu擾---

			// sԃ}[W
			int iLineMargin = ((int)sizeStrDate.Height)/5;
			// ؂ʒu
			int iHorzLineTop_DrawY = 0;
			// ؂ʒu(␳Ȃ)
			int iHorzLineTopNoCorrct_DrawY = 0;

			// ̕`悠
			if (bUseLine==true) {
				// () YW擾  `ʒu - sԃ}[W c`W
				iHorzLineTopNoCorrct_DrawY
					= this.m_iBmpDiameter/2 - (int)sizeStrDate.Height/2 - iLineMargin;
				// [U␳
				iHorzLineTop_DrawY
					= iHorzLineTopNoCorrct_DrawY + this.m_iLinePosCorrection;
				
				// () YW擾  `ʒu - sԃ}[W c`W
				int iHorzLineBottom_DrawY
					= this.m_iBmpDiameter/2 + (int)sizeStrDate.Height/2 + iLineMargin - this.m_iLinePosCorrection;

				// ؂XW
				int iHorzLine_DrawX = this.m_iBmpDiameter+1;

				// ؂YWA摜TCY͈͓̔Ȃ
				if (iHorzLineTop_DrawY>=0 && iHorzLineTop_DrawY<this.m_iBmpDiameter) {
					// XW̕`Jnʒu
					// (~̕`W̓ASYɂ΂̂
					//  XW͉摜f[^̃sNZ̕`F猟A߂)
					// [vJE^ϐ
					int i, len = this.m_iBmpDiameter;
					// 擾ϐ
					Color datColor;
					// [viEj
					for(i=0;i<len;i++) {
						// sNZ擾
						datColor = this.m_datBmp.GetPixel(i, iHorzLineTop_DrawY);

						// sNZlr
						// crbg[xقȂƒridatColor==m_datDrawColor)
						//   łȂ߁Aqfa1r
						if (datColor.R==this.m_datDrawColor.R
							&& datColor.G==this.m_datDrawColor.G
							&& datColor.B==this.m_datDrawColor.B) {

							// `F
							// ؂XW̕`Jnʒu肷
							iHorzLine_DrawX = i+this.m_iLineThickness/2;
							break;
						}
					}
				}

				// ---`s---

				// ()
				this.m_datGraphics.DrawLine(ctrPen, iHorzLine_DrawX, iHorzLineTop_DrawY,
					this.m_iBmpDiameter - iHorzLine_DrawX, iHorzLineTop_DrawY);
				// ()
				this.m_datGraphics.DrawLine(ctrPen, iHorzLine_DrawX,
					iHorzLineBottom_DrawY, this.m_iBmpDiameter - iHorzLine_DrawX, iHorzLineBottom_DrawY);
			}


			// ===================
			// a     ̂̕`    a
			// ===================

			// ---ʒu擾---

			// ttHgƂ̂
			if (this.m_datDateFont != null
				&& (this.m_strAppelTop!=string.Empty || this.m_strAppelBottom!=string.Empty)) {
				//  YW擾  (`ʒu - sԃ}[W)cwW
				int iStrUnderLine_CoorY
					= (int)sizeStrDate.Height/2 + iLineMargin;


				// `惏N̈ʒu擾  cwW
				int iStrAppelFrame_CoorY
					= (int)(System.Math.Sqrt(this.m_iBmpDiameter * this.m_iBmpDiameter/5
					- 24*iStrUnderLine_CoorY*iStrUnderLine_CoorY/25))+iStrUnderLine_CoorY/5;

				// `惏N̈ʒu擾  c`W
				int iStrAppelFrame_DrawY = iRadius - iStrAppelFrame_CoorY;

				// `惏N1ӂ̒擾
				int iStrAppelFrameSide = iStrAppelFrame_CoorY - iStrUnderLine_CoorY;

				// `tHgoϐ擾
				Font datDrawFont    = this.m_datAppelFont;
				// tHgTCYtOuvȂ
				if (this.m_bAppelFontSizeAutoFlag) {
					// ܂܂TCY擾

					// ؂ʒu
					int iSeparatorPos = iRadius - iHorzLineTopNoCorrct_DrawY;
					// ؂͈͓̂Ƃ̂
					if (iHorzLineTopNoCorrct_DrawY>=this.m_iLineThickness
						&& iHorzLineTopNoCorrct_DrawY<(this.m_iBmpDiameter/2-this.m_iLineThickness-1)){

						// ``TCY
						SizeF sizefSquare;
						// `tHg
						Font datDrawFontTop=null;		// `tHgij
						Font datDrawFontBottom=null;	// `tHgij

						// ̕łȂ
						if (this.m_strAppelTop!=string.Empty) {
							// ~̒Ɏ܂``TCY擾
							sizefSquare = this.GetRectSizeInCircle(this.m_strAppelTop, iSeparatorPos);
							// w肳ꂽ`Ɏ܂TCỸtHg擾
							datDrawFontTop = this.GetJustFontSizeFromSquare(
								this.m_datGraphics, this.m_datAppelFont, this.ptyAppelTopForDraw,
								(int)sizefSquare.Width, (int)sizefSquare.Height);
						}

						// ̕łȂ
						if (this.m_strAppelBottom!=string.Empty) {
							// ~̒Ɏ܂``TCY擾
							sizefSquare = this.GetRectSizeInCircle(this.m_strAppelBottom, iSeparatorPos);
							// w肳ꂽ`Ɏ܂TCỸtHg擾
							datDrawFontBottom = this.GetJustFontSizeFromSquare(
								this.m_datGraphics, this.m_datAppelFont, this.ptyAppelBottomForDraw,
								(int)sizefSquare.Width, (int)sizefSquare.Height);
						}

						// `tHg()()Ȃ
						if (datDrawFontTop==null && datDrawFontBottom==null) datDrawFont = null;
							// `tHg()Ȃ`tHg()ݒ
						else if (datDrawFontTop==null) datDrawFont = datDrawFontBottom;
							// `tHg()Ȃ`tHg()ݒ
						else if (datDrawFontBottom==null) datDrawFont = datDrawFontTop;
						else {
							// `tHg()()ƂłȂȂ
							// tHgTCY̏I
							datDrawFont = (datDrawFontTop.Size<datDrawFontBottom.Size)?
							datDrawFontTop : datDrawFontBottom;
						}
					}
				}

				// ̕`
				if (this.m_strAppelTop!=string.Empty && datDrawFont!=null) {
					// `TCY擾()
					System.Drawing.SizeF sizeStrAppelTop
						= this.m_datGraphics.MeasureString(this.ptyAppelTopForDraw, datDrawFont);

					// `ʒu XW擾 (낦)  c`W
					int iStrAppelTop_DrawX = (this.m_iBmpDiameter - (int)sizeStrAppelTop.Width)/2;

					// `ʒu 㑤 YW擾  c`W
					int iStrAppelTop_DrawY = iStrAppelFrame_DrawY
						+ (iStrAppelFrameSide - (int)sizeStrAppelTop.Height)/2;

					// `s
					this.m_datGraphics.DrawString( this.ptyAppelTopForDraw, datDrawFont, ctrBrush, iStrAppelTop_DrawX,    iStrAppelTop_DrawY);

				}

				// ̕`
				if (this.m_strAppelBottom!=string.Empty && datDrawFont!=null) {
					// `TCY擾()
					System.Drawing.SizeF sizeStrAppelBottom
						= this.m_datGraphics.MeasureString(this.ptyAppelBottomForDraw, datDrawFont);

					// `ʒu XW擾 (낦)  c`W
					int iStrAppelBottom_DrawX = (this.m_iBmpDiameter - (int)sizeStrAppelBottom.Width)/2;

					// `ʒu  YW擾 (gŒ낦)  c`W
					int iStrAppelBottom_DrawY
						= this.m_iBmpDiameter - iStrAppelFrame_DrawY
						- (iStrAppelFrameSide - (int)sizeStrAppelBottom.Height)/2 - (int)sizeStrAppelBottom.Height;

					// `s
					this.m_datGraphics.DrawString( this.ptyAppelBottomForDraw, datDrawFont, ctrBrush, iStrAppelBottom_DrawX, iStrAppelBottom_DrawY);

				}

			}
		}
		#endregion yWbNz 摜XV - UpdateImage()


		#region yWbNz w肳ꂽ`Ɏ܂TCỸtHg擾
		/// <summary>
		/// w肳ꂽ`Ɏ܂TCỸtHg擾
		/// </summary>
		/// <param name="graphics">`OtBNX</param>
		/// <param name="fontOrigin">tHg</param>
		/// <param name="strDrawText">`敶</param>
		/// <param name="iDrawWidth">`扡</param>
		/// <param name="iDrawHeight">`捂</param>
		/// <returns>
		/// ꍇ:w肳ꂽ`Ɏ܂TCỸtHgA
		/// sꍇ:null
		/// </returns>
		public Font GetJustFontSizeFromSquare(Graphics graphics, Font fontOrigin, string strDrawText,
			int iDrawWidth, int iDrawHeight) {

			// ZpTCY
			SizeF sizefStr;
			// ZptHg
			Font fontTemp = null;
			// tHgTCY
			float fFontSize = this.m_iBmpDiameter/2;

			// tHgTCY[v
			// ctHgTCY1ĂAw肳ꂽ`
			//   ܂tHgTCYɂȂ炻̃tHgԂB
			while(fFontSize>0) {
				// ZptHg擾
				fontTemp = new Font(fontOrigin.FontFamily, fFontSize, fontOrigin.Style);
				// `TCY擾
				sizefStr = graphics.MeasureString(strDrawText, fontTemp);

				// `TCYw肳ꂔ`Ɏ܂
				if (sizefStr.Width<iDrawWidth && sizefStr.Height<iDrawHeight) {
					break;
				}

				// tHgTCYfNg
				fFontSize --;
			}

			// 擾tHgԂ
			return fontTemp;
		}
		#endregion yWbNz w肳ꂽ`Ɏ܂TCỸtHg擾

		#region yWbNz ~Ɏ܂؂1ӂƂ`TCY擾
		/// <summary>
		/// yWbNz ~Ɏ܂؂1ӂƂ`TCY擾
		/// </summary>
		/// <param name="strName">`悵̕</param>
		/// <param name="iSeparatorPos">؂ʒu</param>
		/// <returns>
		/// ~Ɏ܂؂1ӂƂ`TCY擾
		/// </returns>
		public  SizeF GetRectSizeInCircle(string strName, int iSeparatorPos) {

			// Ȃ
			if (strName==string.Empty) return new SizeF(0, 0);

			// ݌vASY̍
			//                     ______________________________________________
			// q̃[g = (4m^2 r^2 - n^2 t^2)(4m^2 + n^2) + (n^2 t)^2

			// ؂ʒu
			int t = iSeparatorPos;

			// a擾
			decimal r = this.m_iBmpDiameter/2 - this.m_iLineThickness;
			// 䗦 
			decimal m;
			decimal n;
			// cȂ
			if (this.m_eAppelDirection == EnumDirection.eHorz) {
				// 䗦 c c :  = 1 : 
				m = 1;
				n = strName.Length;
			}
			// 񉡏Ȃ
			else {
				// 䗦 c c :  =  : 1
				m = strName.Length;
				n = 1;
			}

			decimal deci4mm_plus_nn = 4 * m*m + n*n;	// Zp 4m^2 + n^2

			//                     ______________________________________________
			// q̃[g = (4m^2 r^2 - n^2 t^2)(4m^2 + n^2) + (n^2 t)^2
			decimal deciNumeratorRootPart = (decimal)System.Math.Sqrt( (double) (
				(4*m*m*r*r - n*n*t*t ) * deci4mm_plus_nn + n*n*t * n*n*t
				) );

			// CP = (-4m^2 nt + n*[g) / m(4m^2 + n^2)
			decimal deciCP = (-4*m*t + n* deciNumeratorRootPart)/deci4mm_plus_nn;
			// BP = ( -4m^2t  +  [g) / (4m^2 + n^2)
			decimal deciBP = (-4*m*m*t + deciNumeratorRootPart)/deci4mm_plus_nn;

			// ߂lTCYiCP, BPj
			SizeF sizef = new SizeF((float)deciCP, (float)deciBP);
			return sizef;

		}
		#endregion yWbNz ~Ɏ܂؂1ӂƂ`擾

		#region yWbNz ̃tHgXV - UpdateAppelFont
		/// <summary>
		/// yWbNz ̃tHgXV
		/// </summary>
		public void UpdateAppelFont() {
			// tHgTCY0ȉȂ
			if (this.m_fAppelFontSize<=0) {
				// tHgj
				this.m_datAppelFont = null;
				return;
			}

			// tHgX^C
			System.Drawing.FontStyle datFontStyle = System.Drawing.FontStyle.Regular;

			// 
			if (this.m_bAppelFontBold) {
				datFontStyle |= System.Drawing.FontStyle.Bold;
			}

			// Α
			if (this.m_bAppelFontItalic) {
				datFontStyle |= System.Drawing.FontStyle.Italic;
			}

			// tHg
			this.m_datAppelFont = new Font(
				this.m_datAppelFontName,		// tHg
				this.m_fAppelFontSize,	// tHgTCY
				datFontStyle					// tHgX^C
				);

			// tHg͓KpłȂƂ̂
			// tHgf[^Ď擾
			this.m_datAppelFontName = this.m_datAppelFont.Name ;
		}
		#endregion yWbNz ̃tHgXV - UpdateAppelFont

		#region yWbNz ttHgXV - UpdateDateFont
		/// <summary>
		/// ttHgXV
		/// </summary>
		public void UpdateDateFont() {
			// tHgTCY0ȉȂ
			if (this.m_fDateFontSize<=0) {
				// tHgj
				this.m_datDateFont = null;
				return;
			}

			// tHgX^C
			System.Drawing.FontStyle datFontStyle = System.Drawing.FontStyle.Regular;

			// 
			if (this.m_bDateFontBold) {
				datFontStyle |= System.Drawing.FontStyle.Bold;
			}

			// Α
			if (this.m_bDateFontItalic) {
				datFontStyle |= System.Drawing.FontStyle.Italic;
			}

			// tHg
			this.m_datDateFont = new Font(
				this.m_datDateFontName,		// tHg
				this.m_fDateFontSize,	// tHgTCY
				datFontStyle								// tHgX^C
				);

			// tHg͓KpłȂƂ̂
			// tHgf[^Ď擾
			this.m_datDateFontName = this.m_datDateFont.Name ;
		}
		#endregion yWbNz ttHgXV - UpdateDateFont


		#region yWbNz ttHgTCYXV - CalcDateFontSizeAuto
		/// <summary>
		/// yWbNz ttHgTCYXV
		/// </summary>
		public void CalcDateFontSizeAuto() {
			// TCYtOu蓮vȂ珈Ȃ
			if (this.m_bDateFontSizeAutoFlag==false) return;

			// ttHgTCÝA摜TCY3/20
			this.m_fDateFontSize = this.m_iBmpDiameter*3/20;

			// tHgXV
			this.UpdateDateFont();
		}
		#endregion yWbNz ttHgTCYXV - CalcDateFontSizeAuto

		#region yWbNz init@CǍ
		/// <summary>
		/// yWbNz init@CǍ
		/// </summary>
		/// <param name="sioFileIni">init@Cf[^</param>
		/// <returns>t@C쌋</returns>
		public CsLib.FResFile LoadIniFile(ref CsLib.SioFileIni sioFileIni) {
			// init@CNXnull`FbN
			if (sioFileIni == null) return CsLib.FResFile.FailUnknown();

			// ZNV擾
			sioFileIni.SetActiveSection("DateSeal");

			// true 
			string strTrue = true.ToString();
			// ^O
			string strTag;
			// f[^
			string strData;
			// f[^z
			string[] strDataArray;
			// FRGBf[^
			int iColR, iColG, iColB;

			// ===================
			// a    ̃tHg   a
			// ===================

			// ̃tHg
			strTag = "AppelFontBold";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_bAppelFontBold
					= (strData==strTrue)? true : false;
			}

			// ̃tHgΑ
			strTag = "AppelFontItalic";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_bAppelFontItalic
					= (strData==strTrue)? true : false;
			}

			// ̃tHgTCYtO
			strTag = "AppelFontSizeAutoFlag";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_bAppelFontSizeAutoFlag
					= (strData==strTrue)? true : false;
			}

			// ̃tHg
			strTag = "AppelFontName";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_datAppelFontName
					= strData;
			}

			// ̃tHgTCY
			strTag = "AppelFontSize";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_fAppelFontSize
					= CsLib.Func.atof(strData);
			}

			// tHgXV
			this.UpdateAppelFont();


			// ===================
			// a    ttHg   a
			// ===================

			// ttHg
			strTag = "DateFontBold";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_bDateFontBold
					= (strData==strTrue)? true : false;
			}

			// ttHgΑ
			strTag = "DateFontItalic";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_bDateFontItalic
					= (strData==strTrue)? true : false;
			}

			// ttHgTCYtO
			strTag = "DateFontSizeAutoFlag";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_bDateFontSizeAutoFlag
					= (strData==strTrue)? true : false;
			}

			// ttHg
			strTag = "DateFontName";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_datDateFontName
					= strData;
			}

			// ttHgTCY
			strTag = "DateFontSize";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_fDateFontSize
					= CsLib.Func.atof(strData);
			}
			// tHgXV
			this.UpdateDateFont();

			// ===================
			// a        F         a
			// ===================

			// `F
			strTag = "DrawColor";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				// RGBf[^","ŋ؂Ă邽
				// ","ŕz擾
				strDataArray = strData.Split(',');
				// z񐔂3ȏȂf[^L
				if (strDataArray.Length>2) {
					iColR = CsLib.Func.atoi(strDataArray[0]);	// R
					iColG = CsLib.Func.atoi(strDataArray[1]);	// G
					iColB = CsLib.Func.atoi(strDataArray[2]);	// B
					// F
					this.m_datDrawColor
						= System.Drawing.Color.FromArgb(iColR, iColG, iColB);
				}
			}

			// wiF
			strTag = "BackColor";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				// RGBf[^","ŋ؂Ă邽
				// ","ŕz擾
				strDataArray = strData.Split(',');
				// z񐔂3ȏȂf[^L
				if (strDataArray.Length>2) {
					iColR = CsLib.Func.atoi(strDataArray[0]);	// R
					iColG = CsLib.Func.atoi(strDataArray[1]);	// G
					iColB = CsLib.Func.atoi(strDataArray[2]);	// B
					// F
					this.m_datBackColor
						= System.Drawing.Color.FromArgb(iColR, iColG, iColB);
				}
			}

			// ===================
			// a                 a
			// ===================

			// Rʒu␳
			strTag = "LinePosCorrection";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_iLinePosCorrection
					= CsLib.Func.atoi(strData);
			}

			// ̑
			strTag = "LineThickness";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_iLineThickness
					= CsLib.Func.atoi(strData);
			}

			// ===================
			// a       摜        a
			// ===================

			// `TCY
			strTag = "DrawDiameter";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_iDrawDiameter
					= CsLib.Func.atoi(strData);
			}

			// 摜TCY
			strTag = "BmpDiameter";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_iBmpDiameter
					= CsLib.Func.atoi(strData);
			}

			// 摜f[^gktO
			strTag = "StretchImage";
			strData = sioFileIni.GetItem(strTag);
			if (strData!=string.Empty) {
				this.m_bStretchImageFlag
					= (strData==strTrue)? true : false; 	// ACe擾
			}

			// 摜f[^gktO
			strTag = "StretchImageVisible";
			strData = sioFileIni.GetItem(strTag);
			if (strData!=string.Empty) {
				this.m_bStretchImageVisibleFlag
					= (strData==strTrue)? true : false; 	// ACe擾
			}

			// ===================
			// a    ̕     a
			// ===================

			// ̃^eAR
			strTag = "AppelDirection";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				// 񋓑̂𕶎ϊ
				this.m_eAppelDirection
					= (strData==EnumDirection.eVert.ToString())? EnumDirection.eVert : EnumDirection.eHorz;
			}

			// ̕()
			strTag = "AppelTop";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_strAppelTop = strData;
			}

			// ̕()
			strTag = "AppelBottom";
			strData = sioFileIni.GetItem(strTag);	// ACe擾
			if (strData!=string.Empty) {
				this.m_strAppelBottom = strData;
			}

			// 
			return CsLib.FResFile.SuccessRead();
		}
		#endregion yWbNz init@CǍ

		#region yWbNz init@Cɕۑ
		/// <summary>
		/// yWbNz init@Cɕۑ
		/// </summary>
		/// <param name="sioFileIni">init@Cf[^</param>
		/// <returns>t@C쌋</returns>
		public CsLib.FResFile SaveIniFile(ref CsLib.SioFileIni sioFileIni) {
			// init@CNXnull`FbN
			if (sioFileIni == null) return CsLib.FResFile.FailUnknown();

			// ^O
			string strTag;
			// f[^
			string strData;
			// ZNVo^
			sioFileIni.RegistSection("DateSeal");

			// ===================
			// a    ̃tHg   a
			// ===================

			// ̃tHg
			strTag = "AppelFontBold";
			strData = this.m_bAppelFontBold.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ̃tHgΑ
			strTag = "AppelFontItalic";
			strData = this.m_bAppelFontItalic.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ̃tHgTCYtO
			strTag = "AppelFontSizeAutoFlag";
			strData = this.m_bAppelFontSizeAutoFlag.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ̃tHg
			strTag = "AppelFontName";
			strData = this.m_datAppelFontName;
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ̃tHgTCY
			strTag = "AppelFontSize";
			strData = this.m_fAppelFontSize.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^


			// ===================
			// a    ttHg   a
			// ===================

			// ttHg
			strTag = "DateFontBold";
			strData = this.m_bDateFontBold.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ttHgΑ
			strTag = "DateFontItalic";
			strData = this.m_bDateFontItalic.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ttHgTCYtO
			strTag = "DateFontSizeAutoFlag";
			strData = this.m_bDateFontSizeAutoFlag.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ttHg
			strTag = "DateFontName";
			strData = this.m_datDateFontName;
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ttHgTCY
			strTag = "DateFontSize";
			strData = this.m_fDateFontSize.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ===================
			// a        F         a
			// ===================

			// `F
			strTag = "DrawColor";
			strData	= string.Format("{0},{1},{2}",
				this.m_datDrawColor.R, this.m_datDrawColor.G, this.m_datDrawColor.B);
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// wiF
			strTag = "BackColor";
			strData	= string.Format("{0},{1},{2}",
				this.m_datBackColor.R, this.m_datBackColor.G, this.m_datBackColor.B);
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ===================
			// a                 a
			// ===================

			// Rʒu␳
			strTag = "LinePosCorrection";
			strData = this.m_iLinePosCorrection.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ̑
			strTag = "LineThickness";
			strData = this.m_iLineThickness.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ===================
			// a     摜      a
			// ===================

			// `TCY
			strTag = "DrawDiameter";
			strData = this.m_iDrawDiameter.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// 摜TCY
			strTag = "BmpDiameter";
			strData = this.m_iBmpDiameter.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// 摜f[^gktO
			strTag = "StretchImage";
			strData = this.m_bStretchImageFlag.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// 摜f[^r[\tO
			strTag = "StretchImageVisible";
			strData = this.m_bStretchImageVisibleFlag.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ===================
			// a    ̕     a
			// ===================

			// ̃^eAR
			strTag = "AppelDirection";
			strData = this.m_eAppelDirection.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ̕()
			strTag = "AppelTop";
			strData = this.m_strAppelTop.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// ̕()
			strTag = "AppelBottom";
			strData = this.m_strAppelBottom.ToString();
			sioFileIni.RegistItem(strTag, strData);	// ACeo^

			// 
			return CsLib.FResFile.SuccessWrite();
		}
		#endregion yWbNz init@Cɕۑ
	}
}
