using System;
using System.Collections;

namespace CsLib {

	#region yNXzSioFileIniBase  init@CNX
	/// <summary>
	/// Init@CNXNX
	/// oϐB
	/// </summary>
	public abstract class SioFileIniBase{

		#regionyNXzACeNX@@DatFileIniItem
		///@{\\\\\\\\\\\\\\\\{
		///@bACeNX@DatFileIniItem@b
		///@{\\\\\\\\\\\\\\\\{
		///@b@oϐ@@@@@@@@@@b
		///@b@EL[@@@@@@@@@@@@b
		///@b@Ee@@@@@@@@@@@@b
		///@{\\\\\\\\\\\{\\\\{
		///@b@public@@@@@@@bACeb
		///@{\\\\\\\\\\\{\\\\{
		///@b@@o^iL[Aejb@@@b
		///@b@@o^(1s) @@@@b@@@b
		///@b@@(e)擾@@@@b@@@b
		///@b@@(1s)擾 @@@@b@@@b
		///@b@@(L[)擾@@@@b@@@b
		///@b@@(e)擾@@@@b@@@b
		///@{\\\\\\\\\\\{\\\\{
		///@b@private @@@@@@bACeb
		///@{\\\\\\\\\\\{\\\\{
		///@b@BL@@o^(string)@b@@@b
		///@b@BL@@擾()@@@@b@@@b
		///@{\\\\\\\\\\\{\\\\{
		///@<summary>
		/// ACeNX  DatFileIniItem
		/// </summary>
		protected class DatFileIniItem{

			#region yoϐzL[
			/// <summary>
			/// L[
			/// </summary>
			private string m_strKey;
			#endregion yoϐzL[

			#region yoϐze
			/// <summary>
			/// e
			/// </summary>
			private string m_strContent;
			#endregion yoϐze

			#region yoϐzRg
			/// <summary>
			/// Rg
			/// </summary>
			private string m_strComment;
			#endregion yoϐzRg


			#region yWbNzACeo^(L[AeARg)
			/// <summary>
			/// ACeo^(L[AeARg)
			/// </summary>
			/// <param name="strKey">L[</param>
			/// <param name="strContent">e</param>
			/// <param name="strComment">Rg</param>
			/// <returns>FRes or FRess</returns>
			public FRes RegistItem(string strKey, string strContent, string strComment){
				if (strKey==string.Empty) return FRes.Fail();

				// L[
				this.m_strKey = strKey;
				// e
				this.m_strContent = strContent;
				// Rg
				this.m_strComment = strComment;

				return FRes.Success();
			}
			#endregion yWbNzACeo^(L[Ae)

			#region yWbNzACeo^(L[Ae)
			/// <summary>
			/// ACeo^(L[Ae)
			/// </summary>
			/// <param name="strKey">L[</param>
			/// <param name="strContent">e</param>
			/// <returns>FRes or FRess</returns>
			public FRes RegistItem(string strKey, string strContent){
				if (strKey==string.Empty) return FRes.Fail();

				// L[
				this.m_strKey = strKey;
				// e
				this.m_strContent = strContent;

				return FRes.Success();
			}
			#endregion yWbNzACeo^(L[Ae)

			#region yWbNzACeo^(1s񂩂̓o^)
			/// <summary>
			/// ACeo^(1s񂩂̓o^)
			/// </summary>
			/// <param name="strOnline">1s</param>
			/// <returns>FRes or FRess</returns>
			public FRes RegistItem_Online(string strOnline){
				// "="
				int iPos = strOnline.IndexOf(s_strKeySplitter);

				// "="ȂΎs
				if (iPos<0) return FRes.Fail();

				// L[擾
				string strKey = Func.Substring(strOnline, 0, iPos);

				// e擾
				string strContent = Func.Substring(strOnline, iPos+s_strKeySplitter.Length);

				// ACeo^
				return this.RegistItem(strKey, strContent);
			}
			#endregion yWbNzACeo^

			#region yWbNzRgo^(Rg)
			/// <summary>
			/// Rgo^(Rg)
			/// </summary>
			/// <param name="strComment">Rg</param>
			/// <returns>FRes or FRess</returns>
			public FRes RegistComment(string strComment){
				// Rg
				this.m_strComment = strComment;

				return FRes.Success();
			}
			#endregion yWbNzACeo^(L[Ae)


			#region yWbNzL[擾
			/// <summary>
			/// yWbNzL[擾
			/// </summary>
			/// <returns>L[</returns>
			public string GetKey(){
				return this.m_strKey;
			}
			#endregion yWbNzL[擾

			#region yWbNze擾
			/// <summary>
			/// yWbNze擾
			/// </summary>
			/// <returns>e</returns>
			public string GetContents(){
				return this.m_strContent;
			}
			#endregion yWbNze擾

			#region yWbNz1s擾
			/// <summary>
			/// yWbNz1s擾
			/// </summary>
			/// <returns>1s</returns>
			public string GetOneLine(){
				return this.m_strKey + SioFileIni.s_strKeySplitter + this.m_strContent;
			}
			#endregion yWbNz1s擾

		}
		#endregion yNXzACeNX  DatFileIniItem

		#region yNXzZNVNX  DatFileIniSection
		// +------------------------------------------------------+
		// |  ZNVNX  DatFileIniSection                 |
		// +------------------------------------------------------+
		// | oϐ                                           |
		// | ETuZNVz                                 |
		// | EACez                                       |
		// +------------------------+----------------+------------+
		// | public                 | TuZNV |  ACe  |
		// +------------------------+----------------+------------+
		// |    o^(string)        |              |          |
		// |    擾(int)           |              |          |
		// |    擾(string)        |              |          |
		// |    Xg擾        |              |          |
		// +------------------------+----------------+------------+
		// | private                | TuZNV |  ACe  |
		// +------------------------+----------------+------------+
		// | BL   o^(ACe)    |              |          |
		// | BL   擾(int)         |              |          |
		// +------------------------+----------------+------------+
		/// <summary>
		/// ZNVNX  DatFileIniSection
		/// </summary>
		protected class DatFileIniSection {

			#region yoϐzG[bZ[W
			/// <summary>
			/// G[bZ[W
			/// </summary>
			System.Text.StringBuilder m_strErrorMessage = new System.Text.StringBuilder();
			#endregion yoϐzG[bZ[W

			#region yoϐzZNV
			/// <summary>
			/// ZNV
			/// </summary>
			string m_strName;
			#endregion yoϐzZNV

			#region yoϐzTuZNVz
			/// <summary>
			/// TuZNVz
			/// </summary>
			ArrayList m_datSubSectionList = new ArrayList();
			#endregion yoϐzTuZNVz

			#region yoϐzACeXg
			/// <summary>
			/// ACeXg
			/// </summary>
			ArrayList m_datItemList = new ArrayList();
			#endregion yoϐzACeXg

			#region yoϐzTux
			/// <summary>
			/// yoϐzTux
			/// </summary>
			private int m_iSubLevel = 0;
			#endregion yoϐzTux

			#region yoϐzeZNV̎Q
			/// <summary>
			/// eZNV̎Q
			/// </summary>
			DatFileIniSection m_datParentSection_ref = null;
			#endregion yoϐzeZNV̎Q


			#region yWbNzZNVݒ
			/// <summary>
			/// yWbNzZNVݒ
			/// </summary>
			/// <param name="strName">ZNV</param>
			public void SetName(string strName){
				this.m_strName = strName;
			}
			#endregion yWbNzZNVݒ

			#region yWbNzZNVETuxݒ(^OtZNV)
			/// <summary>
			/// yWbNzZNVo^(^OtZNV)
			/// </summary>
			/// <param name="strOneLine">^OtZNV</param>
			/// <returns>FRes or FRess</returns>
			public FRes SetSection_FromOneLine(string strOneLine){
				// 񂪋Ȃo^sԂ
				if (strOneLine==null || strOneLine.Length<=0) return FRes.Fail();

				// 擪Tux擾
				int iHeaderSubLevel = GetHeaderSubLevel_FromString(strOneLine);

				// Tux擾
				int iTailSubLevel = GetTailSubLevel_FromString(strOneLine);

				// 擪Tux0ȉȂo^sԂ
				if (iHeaderSubLevel<=0) return FRes.Fail();

				// ZNV擾
				string strNameBody = Func.Substring(strOneLine,
					iHeaderSubLevel,
					strOneLine.Length - iHeaderSubLevel - iTailSubLevel);

				// Tuxݒ
				this.m_iSubLevel = iHeaderSubLevel;

				// ZNVݒ肷
				this.SetName(strNameBody);

				// ZNVݒ肷
				return FRes.Success();

			}
			#endregion yWbNzZNVo^(^OtZNV)

			#region yWbNzZNV擾
			/// <summary>
			/// yWbNzZNV擾
			/// </summary>
			/// <returns>ZNV</returns>
			public string GetName(){
				return this.m_strName;		// ZNVԂ
			}
			#endregion yWbNzZNV擾

			#region yWbNzZNV[^Ot]擾
			/// <summary>
			/// yWbNzZNV擾
			/// </summary>
			/// <returns>ZNV</returns>
			public string GetNameWithTag(){
				// ZNV󕶎Ȃ󕶎Ԃ
				if (this.m_strName==string.Empty) return this.m_strName;

				// 擪^O
				string strHeaderTag = string.Empty;
				// ^O
				string strTailTag = string.Empty;

				// Tux^OA
				for(int i=0;i<this.m_iSubLevel;i++){
					strHeaderTag += SioFileIni.s_strSectionHeaderTag;	// 擪^O
					strTailTag   += SioFileIni.s_strSectionTailTag;		// ^O
				}
				// ZNVɃ^OtĕԂ
				return strHeaderTag + this.m_strName + strTailTag;
			}
			#endregion yWbNzZNV[^Ot]擾

			#region yWbNzTux擾
			/// <summary>
			/// yWbNzTux擾
			/// </summary>
			/// <returns>Tux</returns>
			public int GetSubLevel(){
				return this.m_iSubLevel;
			}
			#endregion yWbNz擾

			#region yWbNzeZNV̎QƎ擾
			/// <summary>
			/// yWbNzeZNV̎QƎ擾
			/// </summary>
			/// <returns>eZNV̎Q</returns>
			public DatFileIniSection GetParentSection(){
				return m_datParentSection_ref;
			}
			#endregion yWbNzeZNV̎QƎ擾

			#region yWbNzZZNV̎QƎ擾(ZNV)
			/// <summary>
			/// ZZNV̎QƎ擾
			/// </summary>
			/// <param name="strName">ZNV</param>
			/// <returns>ZZNV̎Q</returns>
			public DatFileIniSection GetBrosSection(string strName){
				// ZNVf[^
				DatFileIniSection datSection = this.GetParentSection();

				// eZNVf[^nullȂ玸slnullԂ
				if (datSection==null) return null;

				// ZNV
				int iIndex = datSection.GetSubSectionIndex(strName);

				// ZZNV擾
				datSection = datSection.GetSubSection(iIndex);

				// ANeBuZNV̐ݒ
				return datSection;
			}
			#endregion yWbNzZZNV̎QƎ擾(ZNV)

			#region yWbNzZZNV̎QƎ擾(CfbNX)
			/// <summary>
			/// ZZNV̎QƎ擾
			/// </summary>
			/// <param name="iIndex">CfbNX</param>
			/// <returns>ZZNV̎Q</returns>
			public DatFileIniSection GetBrosSection(int iIndex){
				// ZNVf[^
				DatFileIniSection datSection = this.GetParentSection();

				// eZNVf[^nullȂ玸slԂ
				if (datSection==null) return null;

				// ZZNV擾
				datSection = datSection.GetSubSection(iIndex);

				// ANeBuZNV̐ݒ
				return datSection;
			}
			#endregion yWbNzZZNV̎QƎ擾(CfbNX)

			#region yWbNzTuZNVo^[BL] (TuZNV)
			/// <summary>
			/// yWbNzTuZNVo^[BL] (TuZNV)
			/// </summary>
			/// <param name="datSection">TuZNV</param>
			/// <returns>FRes or FRess</returns>
			private DatFileIniSection RegistSubSection_BL(DatFileIniSection datSection){

				// Tuxݒ
				datSection.m_iSubLevel = this.m_iSubLevel+1;

				// eZNV̎QƂݒ
				datSection.m_datParentSection_ref = this;

				// TuZNVɓo^ς݂łȂ`FbN
				int iIndex = this.GetSubSectionIndex(datSection.GetName());

				// TuZNVɓo^ς݂Ȃ㏑
				if (iIndex>=0) {
					// TuZNVXgɒǉ
					this.m_datSubSectionList[iIndex] = datSection;
				}
				else{
					// TuZNVXgɒǉ
					this.m_datSubSectionList.Add(datSection);
				}

				// o^TuZNVԂ
				return datSection;
			}
			#endregion yWbNzTuZNVo^[BL] (TuZNV)

			#region yWbNzTuZNVo^ (TuZNV)
			/// <summary>
			/// yWbNzTuZNVo^ (TuZNV)
			/// </summary>
			/// <param name="strName">TuZNV</param>
			/// <returns>o^ZNV̎Q</returns>
			public DatFileIniSection RegistSubSection(string strName){
				// TuZNṼCX^X
				DatFileIniSection datSection = new DatFileIniSection();

				// TuZNV̖OZbg
				datSection.SetName(strName);

				// TuZNVo^
				return this.RegistSubSection_BL(datSection);
			}
			#endregion yWbNzTuZNVo^ (TuZNV)

			#region yWbNzTuZNV擾[BL]
			/// <summary>
			/// TuZNV擾[BL]
			/// </summary>
			/// <param name="iIndex">CfbNX</param>
			/// <returns>TuZNV</returns>
			private DatFileIniSection GetSubSection_BL(int iIndex){
				// CfbNX͈͊OȂnullԂ
				if (iIndex<0 || iIndex>=this.m_datSubSectionList.Count) return null;

				// zindexԖڂ̃TuZNVԂ
				return (DatFileIniSection)this.m_datSubSectionList[iIndex];
			}
			#endregion yWbNzTuZNV擾[BL]

			#region yWbNzTuZNV擾(CfbNX)
			/// <summary>
			/// yWbNzTuZNV擾(CfbNX)
			/// </summary>
			/// <returns>TuZNV</returns>
			public string GetSubSectionName(int iIndex){
				// TuZNV擾
				DatFileIniSection datSubSection = this.GetSubSection_BL(iIndex);

				// TuZNV擾łȂ󕶎Ԃ
				if (datSubSection==null) return null;

				// TuZNVԂ
				return datSubSection.GetName();
			}
			#endregion yWbNzTuZNV擾(CfbNX)

			#region yWbNzTuZNVCfbNX擾(TuZNV)
			/// <summary>
			/// yWbNzTuZNVCfbNX擾(TuZNV)
			/// </summary>
			/// <param name="strName">TuZNV</param>
			/// <returns>CfbNX</returns>
			public int GetSubSectionIndex(string strName){
				// TuZNV擾
				DatFileIniSection datSubSection ;

				// TuZNV
				int iLength = this.m_datSubSectionList.Count;

				// [v
				for(int iIndex=0;iIndex<iLength;iIndex++){
					// TuZNV擾
					datSubSection = this.GetSubSection_BL(iIndex);
					// ACe擾łȂ玟
					if (datSubSection==null) continue;

					// TuZNVv炱̃CfbNXԂ
					if (strName==datSubSection.GetName()) return iIndex;
				}

				// Ō܂ŌĂvL[-1Ԃ
				return -1;
			}
			#endregion yWbNzTuZNVCfbNX擾(TuZNV)

			#region yWbNzTuZNV擾()
			/// <summary>
			/// yWbNzTuZNV擾()
			/// </summary>
			/// <returns>TuZNV</returns>
			public int GetSubSectionCount(){
				// TuZNV擾łȂ0Ԃ
				if (this.m_datSubSectionList==null) return 0;

				// TuZNVԂ
				return this.m_datSubSectionList.Count;
			}
			#endregion yWbNzTuZNV擾()

			#region yWbNzTuZNV擾 (CfbNX)
			/// <summary>
			/// yWbNzTuZNV擾 (CfbNX)
			/// </summary>
			/// <param name="iIndex">CfbNX</param>
			/// <returns>TuZNV</returns>
			public DatFileIniSection GetSubSection(int iIndex){
				// ZNV擾
				return this.GetSubSection_BL(iIndex);
			}
			#endregion yWbNzZNV擾 (ZNV)

			#region yWbNzTuZNV擾 (ZNV)
			/// <summary>
			/// yWbNzTuZNV擾 (CfbNX)
			/// </summary>
			/// <param name="strName">ZNV</param>
			/// <returns>TuZNV</returns>
			public DatFileIniSection GetSubSection(string strName){
				int iIndex = this.GetSubSectionIndex(strName);
				// ZNV擾
				return this.GetSubSection_BL(iIndex);
			}
			#endregion yWbNzZNV擾 (ZNV)

			#region yWbNzACeo^[BL] (ACe)
			/// <summary>
			/// ACeo^[BL] (ACe)
			/// </summary>
			/// <param name="datItem">ACẽCX^X</param>
			private FRes RegistItem_BL(DatFileIniItem datItem){

				// ACeɓo^ς݂łȂ`FbN
				int iIndex = this.GetItemIndex(datItem.GetKey());

				// ACeɓo^ς݂Ȃ㏑
				if (iIndex>=0) {
					// ACeXgɒǉ
					this.m_datItemList[iIndex] = datItem;

				}
				else{
					// ACeXgɒǉ
					this.m_datItemList.Add(datItem);
				}

				// ACeo^
				return FRes.Success();
			}
			#endregion yWbNzACeo^[BL] (ACe)

			#region yWbNzACeo^(L[, e)
			/// <summary>
			/// ACeo^(L[, e)
			/// </summary>
			/// <param name="strKey">L[</param>
			/// <param name="strContent">e</param>
			public FRes RegistItem(string strKey, string strContent){
				// ACẽCX^X
				DatFileIniItem datItem =new DatFileIniItem();

				// ACẽL[ƓeZbg
				FRes fr = datItem.RegistItem(strKey, strContent);

				// o^łȂ炻̂܂܎sԂ
				if (fr.IsSuccess()==false) return fr;

				// ACeo^
				return this.RegistItem_BL(datItem);
			}
			#endregion yWbNzACeo^(L[, e)

			#region yWbNzACeo^(L[, e, Rg)
			/// <summary>
			/// ACeo^(L[, e, Rg)
			/// </summary>
			/// <param name="strKey">L[</param>
			/// <param name="strContent">e</param>
			/// <param name="strComment">Rg</param>
			/// <returns>FRes or FRess</returns>
			public FRes RegistItem(string strKey, string strContent, string strComment){
				// ACẽCX^X
				DatFileIniItem datItem =new DatFileIniItem();

				// ACẽL[ƓeZbg
				FRes fr = datItem.RegistItem(strKey, strContent, strComment);

				// o^łȂ炻̂܂܎sԂ
				if (fr.IsSuccess()==false) return fr;

				// ACeo^
				return this.RegistItem_BL(datItem);
			}
			#endregion yWbNzACeo^(L[, e)

			#region yWbNzACeo^(Rg)
			/// <summary>
			/// ACeo^(Rg)
			/// </summary>
			/// <param name="strComment">Rg</param>
			/// <returns>FRes or FRess</returns>
			public FRes RegistComment(string strComment){
				// ACẽCX^X
				DatFileIniItem datItem =new DatFileIniItem();

				// ACẽL[ƓeZbg
				FRes fr = datItem.RegistComment(strComment);

				// o^łȂ炻̂܂܎sԂ
				if (fr.IsSuccess()==false) return fr;

				// ACeXgɒǉ(RgACe͋ǉ)
				this.m_datItemList.Add(datItem);

				// ACeo^
				return FRes.Success();
			}
			#endregion yWbNzACeo^(Rg)

			#region yWbNzACeo^(1s񂩂̓o^)
			/// <summary>
			/// ACeo^(1s񂩂̓o^)
			/// </summary>
			/// <param name="strOnline">1s</param>
			/// <returns>FRes or FRess</returns>
			public FRes RegistItem_Online(string strOnline){
				// ACẽCX^X
				DatFileIniItem datItem =new DatFileIniItem();

				// ACẽL[ƓeZbg
				FRes fr = datItem.RegistItem_Online(strOnline);

				// o^łȂ炻̂܂܎sԂ
				if (fr.IsSuccess()==false) return fr;

				// ACeo^
				return this.RegistItem_BL(datItem);
			}
			#endregion yWbNzACeo^

			#region yWbNzACe擾[BL]
			/// <summary>
			/// ACe擾[BL]
			/// </summary>
			/// <param name="iIndex">CfbNX</param>
			/// <returns>ACe</returns>
			public DatFileIniItem GetItem_BL(int iIndex){
				// CfbNX͈͊OȂnullԂ
				if (iIndex<0 || iIndex>=this.m_datItemList.Count) return null;

				// zindexԖڂ̃ACeԂ
				return (DatFileIniItem)this.m_datItemList[iIndex];
			}
			#endregion yWbNzACe擾[BL]

			#region yWbNzACeL[擾(int)
			/// <summary>
			/// yWbNzACeL[擾(int)
			/// </summary>
			/// <returns>L[</returns>
			public string GetItemKey(int iIndex){
				// ACe擾
				DatFileIniItem datItem = this.GetItem_BL(iIndex);

				// ACe擾łȂ󕶎Ԃ
				if (datItem==null) return string.Empty;

				// ACẽL[Ԃ
				return datItem.GetKey();
			}
			#endregion yWbNzACeL[擾(int)

			#region yWbNzACee擾(int)
			/// <summary>
			/// yWbNzACee擾(int)
			/// </summary>
			/// <returns>e</returns>
			public string GetItemContents(int iIndex){
				// ACe擾
				DatFileIniItem datItem = this.GetItem_BL(iIndex);

				// ACe擾łȂ󕶎Ԃ
				if (datItem==null) return string.Empty;

				// ACe̓eԂ
				return datItem.GetContents();
			}
			#endregion yWbNzACee擾(int)

			#region yWbNzACe擾(L[)
			/// <summary>
			/// yWbNzACe擾(L[)
			/// </summary>
			/// <param name="strKey">L[</param>
			/// <returns>ACe</returns>
			public DatFileIniItem GetItem(string strKey){
				// ACeCfbNX擾
				int iIndex = this.GetItemIndex(strKey);

				// ACe擾
				DatFileIniItem datItem = this.GetItem_BL(iIndex);

				// ACe擾łȂ󕶎Ԃ
				if (datItem==null) return null;

				// ACeԂ
				return datItem;
			}
			#endregion yWbNzACe擾(L[)

			#region yWbNzACeCfbNX擾(L[)
			/// <summary>
			/// yWbNzACeCfbNX擾(L[)
			/// </summary>
			/// <param name="strKey"></param>
			/// <returns></returns>
			public int GetItemIndex(string strKey){
				// ACe
				DatFileIniItem datItem;

				// ACe
				int iLength = this.m_datItemList.Count;

				// [v
				for(int iIndex=0;iIndex<iLength;iIndex++){
					// ACe擾
					datItem = this.GetItem_BL(iIndex);
					// ACe擾łȂ玟
					if (datItem==null) continue;

					// L[񂪈v炱̃CfbNXԂ
					if (strKey==datItem.GetKey()) return iIndex;
				}

				// Ō܂ŌĂvL[-1Ԃ
				return -1;
			}
			#endregion yWbNzACeCfbNX擾(L[)

			#region yWbNzACe擾()
			/// <summary>
			/// yWbNzACe擾()
			/// </summary>
			/// <returns>ACe</returns>
			public int GetItemCount(){
				// ACe擾łȂ0Ԃ
				if (this.m_datItemList==null) return 0;

				// ACeԂ
				return this.m_datItemList.Count;
			}
			#endregion yWbNzACe擾()

			#region yWbNz̐擪^O̐𐔂
			/// <summary>
			/// yWbNz̐擪^O̐𐔂
			/// </summary>
			/// <param name="strOneLine">1s</param>
			/// <returns>擪^O̐</returns>
			static public int GetHeaderSubLevel_FromString(string strOneLine){
				// 񂪋ȂuɓKȂvԂ
				if (strOneLine==null || strOneLine.Length<=0) return 0;

				int iLength = strOneLine.Length;	// ^ꂽ̒擾
				int iSubLevel = 0;					// Tux
				string strTag = SioFileIni.s_strSectionHeaderTag;	// ^O
				int iTagLength = strTag.Length;						// ^O
				bool bTemp;		// r

				// 擪^O̐𐔂郋[v
				for(int iPos=0; iPos<iLength; iPos+=iTagLength){
					// 擪^Oƕr
					bTemp = Func.CompareStr(strOneLine, iPos, strTag, 0, iTagLength);
					// r
					if (bTemp==false){
						break;
					}
					// 擪^O̐(Tux)CNg
					iSubLevel++;
				}

				// 擪^O̐(Tux)Ԃ
				return iSubLevel;
			}
			#endregion yWbNz񂪃^OtZNV̏ł邩mF

			#region yWbNz̖^O̐𐔂
			/// <summary>
			/// yWbNz̖^O̐𐔂
			/// </summary>
			/// <param name="strOneLine">1s</param>
			/// <returns>^O̐</returns>
			static public int GetTailSubLevel_FromString(string strOneLine){
				// 񂪋ȂuɓKȂvԂ
				if (strOneLine==null || strOneLine.Length<=0) return 0;

				int iLength = strOneLine.Length;	// ^ꂽ̒擾
				int iSubLevel = 0;					// Tux
				string strTag = SioFileIni.s_strSectionTailTag;	// ^O
				int iTagLength = strTag.Length;					// ^O
				bool bTemp;		// r

				// ^O̐𐔂郋[v
				for(int iPos=iLength - iTagLength; iPos>=0; iPos-=iTagLength){
					// ^Oƕr
					bTemp = Func.CompareStr(strOneLine, iPos, strTag, 0, iTagLength);
					// r
					if (bTemp==false){
						break;
					}
					// ^O̐(Tux)CNg
					iSubLevel++;
				}

				// ^O̐(Tux)Ԃ
				return iSubLevel;
			}
			#endregion yWbNz񂪃^OtZNV̏ł邩mF

			#region yWbNz񂪃^OtZNV̏ł邩mF
			/// <summary>
			/// 񂪃^OtZNV̏ł邩mF
			/// </summary>
			/// <param name="strOneLine">1s</param>
			/// <param name="bFormal">tH[}bg</param>
			/// <returns>ɓK:true, ɓKȂ:false</returns>
			static public bool IsFormat(string strOneLine, bool bFormal){
				// 񂪋ȂuɓKȂvԂ
				if (strOneLine==null || strOneLine.Length<=0) return false;

				// 擪Tux擾
				int iHeaderSubLevel = GetHeaderSubLevel_FromString(strOneLine);

				// Tux擾
				int iTailSubLevel = GetTailSubLevel_FromString(strOneLine);

				// 擪Tux0ȉȂuɓKȂvԂ
				if (iHeaderSubLevel<=0) return false;

				// tH[}bgǂ𒲂ׂȂ
				if (bFormal==true){
					// 擪TuxƖTuxłȂȂuɓKȂvԂ
					if (iHeaderSubLevel!=iTailSubLevel) return false;
				}

				// uɓKvԂ
				return true;
			}
			#endregion yWbNz񂪃^OtZNV̏ł邩mF

			#region yWbNz^OtZNVZNV擾
			/// <summary>
			/// yWbNz^OtZNVZNV擾
			/// </summary>
			/// <param name="strOneLine">1s</param>
			/// <returns>ZNV</returns>
			static public string GetName_FromTag(string strOneLine){
				// 񂪋Ȃ
				if (strOneLine==null || strOneLine.Length<=0) return string.Empty;

				// 擪^O擾
				int iHeaderSubLevel = GetHeaderSubLevel_FromString(strOneLine);

				// ^O擾
				int iTailSubLevel = GetTailSubLevel_FromString(strOneLine);

				// ZNV擾
				string strNameBody = Func.Substring(strOneLine,
					iHeaderSubLevel,
					strOneLine.Length - iHeaderSubLevel - iTailSubLevel);

				// ZNVԂ
				return strNameBody;
			}
			#endregion yWbNz^OtZNVZNV擾

			#region yWbNzG[bZ[W擾
			/// <summary>
			/// yWbNzG[bZ[W擾
			/// </summary>
			/// <returns>G[bZ[W</returns>
			public string GetErrorMessage(){
				// G[bZ[WԂ
				return this.m_strErrorMessage.ToString();
			}
			#endregion yWbNzG[bZ[W擾

			#region yWbNzG[bZ[W
			/// <summary>
			/// yWbNzG[bZ[W
			/// </summary>
			public void ClearErrorMessage(){
				// G[bZ[W
				this.m_strErrorMessage = new System.Text.StringBuilder();
			}
			#endregion yWbNzG[bZ[W

			#region yWbNzG[bZ[Wǉ
			/// <summary>
			/// yWbNzG[bZ[Wǉ
			/// </summary>
			public void AddErrorMessage(string strMsg){
				// G[bZ[Wǉ
				this.m_strErrorMessage.Append(strMsg);
			}
			#endregion yWbNzG[bZ[Wǉ

			#region yWbNzG[bZ[Wǉ(sR[ht)
			/// <summary>
			/// yWbNzG[bZ[Wǉ(sR[ht)
			/// </summary>
			public void AddErrorMessageLine(string strMsg){
				// G[bZ[Wǉ
				this.m_strErrorMessage.Append(strMsg);
				// sR[h
				this.m_strErrorMessage.Append(System.Environment.NewLine);
			}
			#endregion yWbNzG[bZ[Wǉ(sR[ht)

		}

		#endregion yNXzZNVNX  DatFileIniSection


		#region ystaticϐz"[" ZNV^O擪
		/// <summary>
		/// "[" ZNV^O擪
		/// </summary>
		protected static string s_strSectionHeaderTag = "[";
		#endregion ystaticϐz"[" ZNV^O擪

		#region ystaticϐz"]" ZNV^O
		/// <summary>
		/// "]" ZNV^O
		/// </summary>
		protected static string s_strSectionTailTag = "]";
		#endregion ystaticϐz"]" ZNV^O

		#region ystaticϐz"=" L[ƓẽXvb^
		/// <summary>
		/// "=" L[ƓẽXvb^
		/// </summary>
		protected static string s_strKeySplitter = "=";
		#endregion ystaticϐz"=" L[ƓẽXvb^

		#region ystaticϐzőTux
		/// <summary>
		/// őTux(ftHg25)
		/// </summary>
		protected int m_iMaxSubLevel = 25;
		#endregion ystaticϐzőTux

		#region yoϐzZNVf[^iŏʃZNVj
		/// <summary>
		/// DatFileIniSection ZNVf[^iŏʃZNVj
		/// </summary>
		private DatFileIniSection m_datTopSection = new DatFileIniSection();
		#endregion yoϐzZNVf[^iŏʃZNVj

		#region yoϐzANeBuZNVf[^
		/// <summary>
		/// DatFileIniSection ANeBuZNVf[^
		/// </summary>
		private DatFileIniSection m_datActiveSection = null;
		#endregion yoϐzANeBuZNVf[^

		#region yvpeBzANeBuZNV擾Eݒ肵܂
		/// <summary>
		/// yvpeBzANeBuZNV擾Eݒ肵܂
		/// </summary>
		protected DatFileIniSection ActiveSection{

			get { return this.m_datActiveSection; }
			set {
				if (value!=null) this.m_datActiveSection = value;
			}
		}
		#endregion yvpeBzANeBuZNV擾Eݒ肵܂

		#region yvpeBzANeBuZNV̐eZNV擾܂
		/// <summary>
		/// yvpeBzANeBuZNV̐eZNV擾܂
		/// </summary>
		protected DatFileIniSection ActiveParentSection{

			get { return (this.m_datActiveSection!=null)? 
					this.m_datActiveSection.GetParentSection() : null; }
		}
		#endregion yvpeBzANeBuZNV̐eZNV擾܂

		#region yvpeBzANeBuZNV̎擾
		/// <summary>
		/// yvpeBzANeBuZNV̎擾
		/// </summary>
		/// <returns>ANeBuZNV</returns>
		public string ActiveSectionName{
			get {
				// ANeBuZNV̎擾
				DatFileIniSection datSection = this.ActiveSection;

				// ANeBuZNVꖳ΋󕶎Ԃ
				if (datSection==null) return string.Empty;

				// ANeBuZNVԂ
				return datSection.GetName();
			}
		}
		#endregion yvpeBzANeBuZNV̎擾()

		#region yvpeBzŏʃZNV擾܂
		/// <summary>
		/// yvpeBzŏʃZNV擾܂
		/// </summary>
		protected DatFileIniSection TopSection{

			get { return this.m_datTopSection; }
//			set { this.m_datTopSection = value; }
		}
		#endregion yvpeBzŏʃZNV擾܂


		#region y֐zRXgN^
		/// <summary>
		/// y֐zRXgN^
		/// </summary>
		public SioFileIniBase(){
			// NA
			this.Clear();
		}
		#endregion y֐zRXgN^

		#region yWbNzŏʃZNVNA
		/// <summary>
		/// yWbNzŏʃZNVNA
		/// </summary>
		protected void ClearTopSection(){
			this.m_datTopSection = new DatFileIniSection();
			this.m_datTopSection.RegistSubSection(string.Empty);
		}
		#endregion yWbNzŏʃZNVNA

		#region yabstractWbNzNA
		/// <summary>
		/// yabstractWbNzNA
		/// </summary>
		public abstract void Clear();
		#endregion yabstractWbNzNA

		#region yWbNzANeBuZNVqZNV֕ύX(ZNV)
		/// <summary>
		/// ANeBuZNVqZNV֕ύX
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		protected FRes SetActiveSubSection_BL(string strName){
			// ZNV
			DatFileIniSection datSection = this.m_datActiveSection.GetSubSection(strName);

			// ANeBuZNVݒ
			this.ActiveSection = datSection;

			// ݒ̐EsԂ
			return (datSection!=null)? FRes.Success() : FRes.Fail();
		}
		#endregion yWbNzANeBuZNV̐ݒ(ZNV)

		#region yWbNzANeBuZNVZZNV֕ύX(ZNV)
		/// <summary>
		/// ANeBuZNV̐ݒ
		/// ANeBuZNVZZNV֕ύX
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		protected FRes SetActiveBrosSection_BL(string strName){
			DatFileIniSection datSection = this.m_datActiveSection.GetBrosSection(strName);
			return (datSection!=null)? FRes.Success() : FRes.Fail();
		}
		#endregion yWbNzANeBuZNVZZNV֕ύX(ZNV)

		#region yWbNzANeBuZNVeZNV֕ύX(ZNV)
		/// <summary>
		/// ANeBuZNV̐ݒ
		/// ANeBuZNVeZNV֕ύX
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		protected FRes SetActiveParentSection_BL(string strName){
			// ZNVf[^
			DatFileIniSection datSection = this.m_datActiveSection.GetParentSection();

			// ANeBuZNV̐ݒ
			this.ActiveSection = datSection ;

			// ݒ̐EsԂ
			return (datSection!=null)? FRes.Success() : FRes.Fail();
		}
		#endregion yWbNzANeBuZNVeZNV֕ύX(ZNV)

		#region yWbNzACe擾
		/// <summary>
		/// yWbNzACe擾
		/// </summary>
		/// <returns>ACe</returns>
		public int GetItemCount(){
			return this.ActiveSection.GetItemCount();
		}
		#endregion yWbNzACe擾

		#region yWbNzACeCfbNX擾 (L[)
		/// <summary>
		/// yWbNzACeCfbNX擾 (L[)
		/// </summary>
		/// <param name="strKey">L[</param>
		/// <returns>ACeCfbNX</returns>
		public int GetItemIndex(string strKey){
			// ANeBuZNVACe擾
			return this.ActiveSection.GetItemIndex(strKey);
		}
		#endregion yWbNzACeCfbNX擾 (L[)

		#region yWbNzACe擾 (L[)
		/// <summary>
		/// yWbNzACe擾 (L[)
		/// </summary>
		/// <param name="strKey">L[</param>
		/// <returns>e</returns>
		public string GetItem(string strKey){
			// ACẽCX^X擾
			DatFileIniItem datItem = this.ActiveSection.GetItem(strKey);

			// ACe΋󕶎
			if (datItem==null) return string.Empty;

			// ACe̓eԂ
			return datItem.GetContents();
		}
		#endregion yWbNzACe擾 (L[)

		#region yWbNzACeo^(L[Ae)
		/// <summary>
		/// yWbNzACeo^(L[Ae)
		/// </summary>
		/// <param name="strKey">L[</param>
		/// <param name="strContent">e</param>
		/// <returns>FRes or FRess</returns>
		public FRes RegistItem(string strKey, string strContent){
			// ANeBuZNVɓo^
			return this.ActiveSection.RegistItem(strKey, strContent);
		}
		#endregion yWbNzACeo^(L[Ae)

		#region yWbNzACeo^(L[AeARg)
		/// <summary>
		/// yWbNzACeo^(L[Ae)
		/// </summary>
		/// <param name="strKey">L[</param>
		/// <param name="strContent">e</param>
		/// <param name="strComment">Rg</param>
		/// <returns>FRes or FRess</returns>
		public FRes RegistItem(string strKey, string strContent, string strComment){
			// ANeBuZNVɓo^
			return this.ActiveSection.RegistItem(strKey, strContent, strComment);
		}
		#endregion yWbNzACeo^(L[Ae)

		#region yWbNzACe݊mF (ACe)
		/// <summary>
		/// yWbNzACe݊mF (ACe)
		/// </summary>
		/// <param name="strKey">ACe</param>
		/// <returns>݂:trueA݂Ȃ:false</returns>
		public bool IsExistItem(string strKey){
			// CfbNX擾
			int iIndex = this.ActiveSection.GetItemIndex(strKey);

			// CfbNX͈͊OȂACe݂͑Ȃ
			if (iIndex<0) return false;

			// ACe݂͑
			return true;
		}
		#endregion yWbNzACeo^[BL] (ACe)

		#region yWbNzt@CZ[u(string)
		/// <summary>
		/// yWbNzt@CZ[u(string)
		/// </summary>
		/// <param name="strSaveFileName">Z[ut@C</param>
		/// <returns>AsFResl</returns>
		public virtual CsLib.FResFile Save(string strSaveFileName) {
			// Xg[̐
			System.IO.StreamWriter swSaveFile;
			try {
				// Xg[̐
				swSaveFile = new System.IO.StreamWriter(
					strSaveFileName,
					false,  // ㏑ i true = ǉ j
					System.Text.Encoding.GetEncoding("Shift_JIS")) ;
			}
			catch {
				// I[vG[
				return CsLib.FResFile.FailOpen();
			}

			// I[o[[h֐̌Ăяo
			CsLib.FResFile fres = this.Save(ref swSaveFile);

			// Xg[
			swSaveFile.Close();

			// Ǎ݌ʂԂ
			return fres;
		}
		#endregion yWbNzt@CZ[u(string)

		#region yabstract֐zt@CZ[u( System.IO.StreamWriter)
		/// <summary>
		/// yabstract֐zSave
		/// </summary>
		/// <param name="swSaveFile">Xg[</param>
		/// <returns>FRes or FRess</returns>
		public abstract CsLib.FResFile Save(ref System.IO.StreamWriter swSaveFile) ;
		#endregion yabstract֐zt@CZ[u( System.IO.StreamWriter)

		#region yWbNzt@C[h - Load(string)
		/// <summary>
		/// yWbNzt@C[h(string)
		/// </summary>
		/// <param name="strLoadFileName">[ht@C</param>
		/// <returns>AsFResl</returns>
		public virtual FResFile Load(string strLoadFileName) {
			// Xg[̐
			System.IO.StreamReader swLoadFile;

			try {
				// t@CI[v
				swLoadFile = new System.IO.StreamReader(
					strLoadFileName,
					System.Text.Encoding.GetEncoding("Shift_JIS")) ;
			}
			catch {
				// I[vG[
				return FResFile.FailOpen();
			}

			// I[o[[h֐̌Ăяo
			FResFile fres = this.Load(ref swLoadFile);

			// Xg[
			swLoadFile.Close();

			// Ǎ݌ʂԂ
			return fres;
		}
		#endregion yWbNzt@C[h - Load(string)

		#region yabstract֐zt@C[h( System.IO.StreamReader)
		/// <summary>
		/// yabstract֐zLoad
		/// </summary>
		/// <param name="swLoadFile">Xg[</param>
		/// <returns>FRes or FRess</returns>
		public abstract FResFile Load(ref System.IO.StreamReader swLoadFile) ;
		#endregion yabstract֐zt@C[h( System.IO.StreamReader)

	}
	#endregion yNXzSioFileIniBase  init@CNX

	#region yNXzSioFileIni  init@CNX
	/// <summary>
	/// init@CNX ̊Tv̐łB
	/// init@C̕ۑEǂݍ݂s܂
	/// ZNVŕނAL[ƃf[^=łȂŃZbgœo^܂B
	/// ZNV[]Őݒ肵܂B
	/// </summary>
	/// <remarks>
	/// )
	///     [ZNV]
	///     L[=f[^
	/// </remarks>
	public class SioFileIni : SioFileIniBase{

		#region yRgzNX\
		// +-------------------------------------------------------------------+
		// | init@CNX  SioFileIni                                     |
		// +-------------------------------------------------------------------+
		// | oϐ                                                        |
		// | EZNVNX                                                |
		// | EANeBuZNV                                            |
		// +------------------------+------------+----------------+------------+
		// | public                 | ZNV | TuZNV |  ACe  |
		// +------------------------+------------+----------------+------------+
		// |    o^(string)        |          |              |          |
		// |    擾(int)           |          |              |          |
		// |    擾(string)        |          |              |          |
		// |    Xg擾        |     ~     |              |          |
		// | ANeBu擾(int)    |     ~     |              |     ~     |
		// | ANeBu擾(string) |     ~     |              |     ~     |
		// +------------------------+------------+----------------+------------+
		// | private                | ZNV | TuZNV |  ACe  |
		// +------------------------+------------+----------------+------------+
		// | BL   o^(string)      |          |              |          |
		// | BL   擾(int)         |          |              |          |
		// +------------------------+------------+----------------+------------+

		#endregion yRgzNX\

		#region y֐zRXgN^
		/// <summary>
		/// y֐zRXgN^
		/// </summary>
		public SioFileIni(){
		}
		#endregion y֐zRXgN^


		#region yWbNzNA
		/// <summary>
		/// yWbNzNA
		/// </summary>
		public override void Clear(){
			// ŏʃZNVNA
			this.ClearTopSection();
			// ANeBuZNV̍XV
			this.ActiveSection = this.TopSection.RegistSubSection(string.Empty);
		}
		#endregion yWbNzNA

		#region yWbNzZNV擾
		/// <summary>
		/// yWbNzZNV擾
		/// </summary>
		/// <returns>ZNV</returns>
		public int GetSectionCount(){
			return this.TopSection.GetSubSectionCount();
		}
		#endregion yWbNzZNV擾


		#region yWbNzZNVo^[BL] (ZNV)
		/// <summary>
		/// yWbNzZNVo^[BL] (ZNV)
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>o^ZNV̎Q</returns>
		private DatFileIniSection RegistSection_BL(string strName){
			// ŏʃZNṼTuZNVƂēo^
			DatFileIniSection daSection = this.TopSection.RegistSubSection(strName);
			// ANeBuZNVXV
			this.ActiveSection = daSection;
			// o^ZNVԂ
			return daSection;
		}
		#endregion yWbNzZNVo^[BL] (ZNV)

		#region yWbNzZNVo^(ZNV)
		/// <summary>
		/// yWbNzZNVo^(ZNV)
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public FRes RegistSection(string strName){
			// ZNVo^
			DatFileIniSection datSection = this.RegistSection_BL(strName);
			return (datSection!=null)? FRes.Success() : FRes.Fail();
		}
		#endregion yWbNzZNVo^(ZNV)

		#region yWbNzZNVo^[^Ot](ZNV)
		/// <summary>
		/// yWbNzZNVo^[^Ot](ZNV)
		/// </summary>
		/// <param name="strNameWithTag">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public FRes RegistSection_FromTag(string strNameWithTag){
			// ^OtZNV擾
			string strNameBody = DatFileIniSection.GetName_FromTag(strNameWithTag);
			// ZNVo^
			DatFileIniSection datSection = this.RegistSection_BL(strNameBody);
			return (datSection!=null)? FRes.Success() : FRes.Fail();
		}
		#endregion yWbNzZNVo^[^Ot](ZNV)


		#region yWbNzZNVCfbNX擾 (ZNV)
		/// <summary>
		/// yWbNzZNVCfbNX擾 (ZNV)
		/// </summary>
		/// <param name="strSection">ZNV</param>
		/// <returns>ZNVCfbNX</returns>
		public int GetSectionIndex(string strSection){
			// ŏʃZNVTuZNV擾
			return this.TopSection.GetSubSectionIndex(strSection);
		}
		#endregion yWbNzZNVCfbNX擾 (ZNV)

		#region yWbNzZNV݊mF (ZNV)
		/// <summary>
		/// yWbNzZNV݊mF (ZNV)
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>݂:trueA݂Ȃ:false</returns>
		public bool IsExistSection(string strName){
			// CfbNX擾
			int iIndex = this.TopSection.GetSubSectionIndex(strName);

			// CfbNX͈͊OȂZNV݂͑Ȃ
			if (iIndex<0) return false;

			// ZNV݂͑
			return true;
		}
		#endregion yWbNzZNVo^[BL] (ZNV)

		#region yWbNzZNV擾 (CfbNX)
		/// <summary>
		/// yWbNzZNV擾 (CfbNX)
		/// </summary>
		/// <param name="iIndex">CfbNX</param>
		/// <returns>ZNV̎Q</returns>
		private DatFileIniSection GetSection(int iIndex){
			// ZNV擾
			return this.TopSection.GetSubSection(iIndex);
		}
		#endregion yWbNzZNV擾 (CfbNX)

		#region yWbNzZNV擾 (ZNV)
		/// <summary>
		/// yWbNzZNV擾 (ZNV)
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>ZNV</returns>
		protected DatFileIniSection GetSection(string strName){
			// CfbNX擾
			int iIndex = this.TopSection.GetSubSectionIndex(strName);

			// CfbNX͈͊OȂZNV݂͑Ȃ
			if (iIndex<0) return null;

			// ZNV擾
			return this.GetSection(iIndex);
		}
		#endregion yWbNzZNV擾 (ZNV)


		#region yWbNzANeBuZNVύX(ZNV)
		/// <summary>
		/// yWbNzANeBuZNVύX(ZNV)
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public virtual FRes SetActiveSection(string strName){
			// wZNṼCfbNX擾
			int iIndex = this.TopSection.GetSubSectionIndex(strName);
			// wZNV݂ȂΎsԂ
			if (iIndex<0) return FRes.Fail();

			// ANeBuZNVݒ
			this.ActiveSection = this.TopSection.GetSubSection(iIndex);

			// Ԃ
			return FRes.Success();	
		}
		#endregion yWbNzANeBuZNVZZNV֕ύX(ZNV)


		#region yWbNzt@CZ[u(StreamWriter) - Save(ref StreamWriter)
		/// <summary>
		/// yWbNzt@CZ[u(StringWriter) - Save(ref StringWriter)
		/// </summary>
		/// <param name="swSaveFile">Z[ut@C̃Xg[</param>
		/// <returns>AsFResl</returns>
		public override CsLib.FResFile Save(ref System.IO.StreamWriter swSaveFile) {
			DatFileIniSection datSection;	// ZNVf[^
			System.Text.StringBuilder sbAllLine
				= new System.Text.StringBuilder();	// ݑSf[^i[pϐ

			// ZNV擾
			int iSectionCount = this.TopSection.GetSubSectionCount();

			// [v
			// ZNVf[^
			for(int iSec=0;iSec<iSectionCount;iSec++) {
				// ZpϐɊi[
				datSection = this.GetSection(iSec);
				// null `FbN
				if (datSection==null) continue;
				// ZNVZ[u
				this.Save_Section(ref sbAllLine, datSection);
			}

			// t@C
			try {
				// t@C
				swSaveFile.Write(sbAllLine);
			}
			catch {
				// G[
				return CsLib.FResFile.FailWrite();
			}

			// ݐ
			return CsLib.FResFile.SuccessWrite();
		}
		#endregion yWbNzt@CZ[u(StreamWriter) - Save(ref StreamWriter)

		#region yWbNzt@CZ[u[ZNV]
		/// <summary>
		/// yWbNzt@CZ[u[ZNV]
		/// </summary>
		/// <param name="sbAllLine">ݑSf[^i[pϐ</param>
		/// <param name="datSection">ZNV</param>
		/// <returns></returns>
		private CsLib.FRes Save_Section(
			ref System.Text.StringBuilder sbAllLine, DatFileIniSection datSection) {
			DatFileIniItem    datItem;	// ACe
			string strTemp;	// Zp
			// sR[h擾
			string strNewLine = System.Environment.NewLine;

			// ZNV^O
			// "[" + ZNV + "]";
			strTemp = datSection.GetNameWithTag();	// ^OtZNV擾

			// 󕶎łȂ
			if(strTemp != string.Empty) {
				// LR[hGXP[vV[PXϊi'\n'"\n"j
				strTemp = Func.ConvertStr_CcToEs(strTemp);

				sbAllLine.Append(strTemp);		// f[^ǉ
				sbAllLine.Append(strNewLine);	// "\r\n"sǉ
			}

			// ACe[v
			// ACeXg
			for(int iIndex=0;iIndex<datSection.GetItemCount();iIndex++) {
				datItem = datSection.GetItem_BL(iIndex);	// ACe擾

				if (datItem==null) continue;

				strTemp = datItem.GetOneLine();		// 1s擾

				// LR[hGXP[vV[PXϊi'\n'"\n"j
				strTemp = Func.ConvertStr_CcToEs(strTemp);

				sbAllLine.Append(strTemp);			// f[^ǉ
				sbAllLine.Append(strNewLine);		// "\r\n"sǉ
			}
			sbAllLine.Append(strNewLine);	// "\r\n"sǉ

			return FRes.Success();
		}
		#endregion yWbNzt@CZ[u[ZNV]

		#region yWbNzt@C[h - Load(ref System.IO.StreamReader)
		/// <summary>
		/// yWbNzt@C[h(StreamReader)
		/// </summary>
		/// <param name="swLoadFile">[ht@C</param>
		/// <returns>AsFResl</returns>
		public override FResFile Load(ref System.IO.StreamReader swLoadFile) {
			string strTemp;			// Zpϐ
			string strOneLine;		// 1spϐ
			string strSectionName;	// ZNVϐ
			DatFileIniSection datSection; //ZpZNVϐ

			// f[^zɂ
			this.Clear();

			// ZpZNVŏʃZNVɂ킹
			datSection = this.TopSection.GetSubSection(string.Empty);

			// [v
			// 1sǍ
			for(;;) {
				// 1sǍ
				strOneLine = swLoadFile.ReadLine();

				// ǍݏI 
				if (strOneLine==null) break;

				// 擪󔒍폜
				strOneLine = strOneLine.TrimStart();

				// 񂪋Ȃ牽
				if (strOneLine == string.Empty) continue;

				// GXP[vV[PXLR[hϊi"\n"'\n'j
				strTemp = Func.ConvertStr_EsToCc(strOneLine);

				// ZNV^O
				if (DatFileIniSection.IsFormat(strOneLine, false)) {
					// 1s񂩂ZNV擾
					strSectionName = DatFileIniSection.GetName_FromTag(strTemp);

					// ZNV̓o^ivZNV܂o^ȂVKǉj
					datSection = this.RegistSection_BL(strSectionName);
					// ̍s
					continue;
				}

				// ZNV^OłȂΒʏs
				datSection.RegistItem_Online(strTemp);

			}

			// ǍݐԂ
			return FResFile.SuccessRead();
		}
		#endregion yWbNzt@C[h - Load(ref System.IO.StringReader)


	}
	#endregion yNXzSioFileIni  init@CNX

	#region yNXzSioFileIniEx  ginit@CNX Muliple Inter
	/// <summary>
	/// SioFileIniEx  ginit@CNX
	/// ʏinit@CNXg_
	/// 
	/// ETuZNV@\
	///		ZNVKwɂēo^邱Ƃł
	///
	/// EANeBuZNV@\
	///		TuZNV@\̎ɔAqZNVZNṼf[^
	///		삷KvBsAsΏۂ̃ZNV̐ݒ擾sȂB
	///
	/// ERgACe@\
	///		ʏinit@Cɂ̓Rg͂łȂ̂Ŋg@\Ƃ
	///		Rg߂悤ɂB
	/// 
	/// </summary>
	public class SioFileIniMi : SioFileIniBase {

		#region yWbNzNA
		/// <summary>
		/// yWbNzNA
		/// </summary>
		public override void Clear(){
			// ŏʃZNVNA
			this.ClearTopSection();
			// ANeBuZNV̍XV
			this.ActiveSection = this.TopSection;
		}
		#endregion yWbNzNA

		#region yWbNzt@CZ[u(StreamWriter) - Save(ref StreamWriter)
		/// <summary>
		/// yWbNzt@CZ[u(StringWriter) - Save(ref StringWriter)
		/// </summary>
		/// <param name="swSaveFile">Z[ut@C̃Xg[</param>
		/// <returns>AsFResl</returns>
		public override CsLib.FResFile Save(ref System.IO.StreamWriter swSaveFile) {
			System.Text.StringBuilder sbAllLine
				= new System.Text.StringBuilder();	// ݑSf[^i[pϐ

			this.Save_SectionRecursive(ref sbAllLine, this.TopSection);
	
			// t@C
			try {
				// t@C
				swSaveFile.Write(sbAllLine);
			}
			catch {
				// G[
				return CsLib.FResFile.FailWrite();
			}

			// ݐ
			return CsLib.FResFile.SuccessWrite();
		}
		#endregion yWbNzt@CZ[u(StreamWriter) - Save(ref StreamWriter)

		#region yWbNzt@CZ[u ZNVZ[uċA
		/// <summary>
		/// yWbNzt@CZ[u ZNVZ[uċA
		/// </summary>
		/// <param name="sbAllLine"></param>
		/// <param name="datSection"></param>
		/// <returns></returns>
		private FRes Save_SectionRecursive(
			ref System.Text.StringBuilder sbAllLine, DatFileIniSection datSection) {

			DatFileIniSection datSubSection;	// TuZNVϐ
			string strTemp;	// Zp
			DatFileIniItem    datItem;	// ACeϐ
			int iIndex;		// CfbNXϐ
			string strIndent = string.Empty;	// Cfgϐ
			// sR[h擾
			string strNewLine = System.Environment.NewLine;

			// Cfg擾
			for(iIndex=1;iIndex<datSection.GetSubLevel();iIndex++) {
				strIndent += "    ";
			}

			// ZNV^O
			// "[" + ZNV + "]";
			strTemp = datSection.GetNameWithTag();	// ^OtZNV擾

			// ZNV󕶎łȂ
			if(strTemp != string.Empty) {
				// LR[hGXP[vV[PXϊi'\n'"\n"j
				strTemp = Func.ConvertStr_CcToEs(strTemp);

				// ZNV
				sbAllLine.Append(strIndent);	// Cfgǉ
				sbAllLine.Append(strTemp);		// f[^ǉ
				sbAllLine.Append(strNewLine);	// "\r\n"sǉ
			}

			// ACe[v
			// ACeXg
			for(iIndex=0;iIndex<datSection.GetItemCount();iIndex++) {
				datItem = datSection.GetItem_BL(iIndex);	// ACe擾
				strTemp = datItem.GetOneLine();		// 1s擾

				// LR[hGXP[vV[PXϊi'\n'"\n"j
				strTemp = Func.ConvertStr_CcToEs(strTemp);

				// ACe
				sbAllLine.Append(strIndent);		// Cfgǉ
				sbAllLine.Append(strTemp);			// f[^ǉ
				sbAllLine.Append(strNewLine);		// "\r\n"sǉ
			}
			sbAllLine.Append(strNewLine);	// "\r\n"sǉ

			// TuZNV[v
			// TuZNVXg
			for(iIndex=0;iIndex<datSection.GetSubSectionCount();iIndex++) {
				// ZNV擾
				datSubSection = datSection.GetSubSection(iIndex);
				this.Save_SectionRecursive(ref sbAllLine, datSubSection);
			}
			return FRes.Success();
		}
		#endregion yWbNzt@CZ[u ZNVZ[uċA

		#region yWbNzt@C[h - Load(ref System.IO.StreamReader)
		/// <summary>
		/// yWbNzt@C[h(StreamReader)
		/// </summary>
		/// <param name="swLoadFile">[ht@C</param>
		/// <returns>AsFResl</returns>
		public override FResFile Load(ref System.IO.StreamReader swLoadFile) {
			string strTemp;		// Zpϐ
			string strOneLine;	// 1spϐ
			DatFileIniSection datSection; //ZpZNVϐ
			DatFileIniSection datSectionNew; //ZpZNVϐ
			DatFileIniSection datSectionParentTemp; //ZpZNVϐ

			// f[^zɂ
			this.Clear();

			// ZpZNVŏʃZNVɂ킹
			datSection = this.TopSection.GetSubSection(string.Empty);

			// [v
			// 1sǍ
			for(;;) {
				// 1sǍ
				strOneLine = swLoadFile.ReadLine();

				// ǍݏI 
				if (strOneLine==null) break;

				// 擪󔒍폜
				strOneLine = strOneLine.TrimStart();

				// 񂪋Ȃ牽
				if (strOneLine == string.Empty) continue;

				// GXP[vV[PXLR[hϊi"\n"'\n'j
				strTemp = Func.ConvertStr_EsToCc(strOneLine);

				// ZNV^O
				if (DatFileIniSection.IsFormat(strOneLine, false)) {
					// eZNVꎞϐ̍XV
					datSectionParentTemp = datSection;

					// VKZNV쐬
					datSectionNew = new DatFileIniSection();
					// 1s񂩂ZNVETuxݒ
					datSectionNew.SetSection_FromOneLine(strTemp);

					// eZNVꎞϐ
					datSectionParentTemp = datSection;
					// VKTux݂̃ZNV[
					if (datSectionNew.GetSubLevel()>datSectionParentTemp.GetSubLevel()){
						// TuZNVֈڍs
						// Tux1ɂȂ܂Ń[v
						while((datSectionNew.GetSubLevel()-1) > datSectionParentTemp.GetSubLevel()){
							// 󖼏̂̃TuZNVo^
							datSectionParentTemp = datSectionParentTemp.RegistSubSection(string.Empty);
							// ŏʃZNV𒴂G[
							if (datSectionParentTemp.GetSubLevel()>=this.m_iMaxSubLevel) break;
						}
						// o^
						datSection = datSectionParentTemp.RegistSubSection(datSectionNew.GetName());
						// o^s
						if (datSection==null) return FResFile.FailRead();

					}
					else{
						// VKTux݂̃ZNV
						if (datSectionNew.GetSubLevel() < datSectionParentTemp.GetSubLevel()){
							// eZNVֈڍs
							// TuxɂȂ܂Ń[v
							while(datSectionNew.GetSubLevel() == datSectionParentTemp.GetSubLevel()){
								// eZNV擾
								datSectionParentTemp = datSectionParentTemp.GetParentSection();
								// ŏʃZNV𒴂G[
								if (datSectionParentTemp==null) break;
							}
						}
						// VKTux݂̃ZNVƓ͂
						if (datSectionNew.GetSubLevel()!=datSectionParentTemp.GetSubLevel()) {
							return FResFile.FailRead();
						}
						// eZNV擾
						datSectionParentTemp = datSectionParentTemp.GetParentSection();
					}
					// o^
					datSection = datSectionParentTemp.RegistSubSection(datSectionNew.GetName());
					// o^s
					if (datSection==null) return FResFile.FailRead();
					// ̍s
					continue;
				}

				// ZNV^OłȂΒʏs
				datSection.RegistItem_Online(strTemp);

			}

			// ǍݐԂ
			return FResFile.SuccessRead();
		}
		#endregion yWbNzt@C[h - Load(ref System.IO.StringReader)


		#region yWbNzANeBuZNVqZNV֕ύX(ZNV)
		/// <summary>
		/// ANeBuZNVqZNV֕ύX
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public FRes SetActiveSubSection(string strName){
			// ANeBuZNV̐ݒ
			return this.SetActiveSubSection_BL(strName);
		}
		#endregion yWbNzANeBuZNV̐ݒ(ZNV)

		#region yWbNzANeBuZNVZZNV֕ύX(ZNV)
		/// <summary>
		/// ANeBuZNV̐ݒ
		/// ANeBuZNVZZNV֕ύX
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public FRes SetActiveBrosSection(string strName){
			// ANeBuZNV̐ݒ萬
			return this.SetActiveBrosSection_BL(strName);
		}
		#endregion yWbNzANeBuZNVZZNV֕ύX(ZNV)

		#region yWbNzANeBuZNVeZNV֕ύX(ZNV)
		/// <summary>
		/// ANeBuZNV̐ݒ
		/// ANeBuZNVeZNV֕ύX
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public FRes SetActiveParentSection(string strName){
			// ANeBuZNV̐ݒ
			return this.SetActiveParentSection_BL(strName);
		}
		#endregion yWbNzANeBuZNVeZNV֕ύX(ZNV)


		#region yWbNzTuZNVo^[BL] (ZNV)
		/// <summary>
		/// yWbNzTuZNVo^[BL] (ZNV)
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>o^TuZNV̎Q</returns>
		private DatFileIniSection RegistSubSection_BL(string strName){
			// ANeBuZNṼTuZNVƂēo^
			DatFileIniSection daSection = this.ActiveSection.RegistSubSection(strName);
			// ANeBuZNVXV
			this.ActiveSection = daSection;
			// o^ZNVԂ
			return daSection;
		}
		#endregion yWbNzZNVo^[BL] (ZNV)

		#region yWbNzZNVo^(ZNV)
		/// <summary>
		/// yWbNzZNVo^(ZNV)
		/// </summary>
		/// <param name="strName">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public FRes RegistSubSection(string strName){
			// ZNVo^
			DatFileIniSection datSection = this.RegistSubSection_BL(strName);
			return (datSection!=null)? FRes.Success() : FRes.Fail();
		}
		#endregion yWbNzZNVo^(ZNV)

		#region yWbNzZNVo^[^Ot](ZNV)
		/// <summary>
		/// yWbNzZNVo^[^Ot](ZNV)
		/// </summary>
		/// <param name="strNameWithTag">ZNV</param>
		/// <returns>FRes or FRess</returns>
		public FRes RegistSubSection_FromTag(string strNameWithTag){
			// ^OtZNV擾
			string strNameBody = DatFileIniSection.GetName_FromTag(strNameWithTag);
			// ZNVo^
			DatFileIniSection datSection = this.RegistSubSection_BL(strNameBody);
			return (datSection!=null)? FRes.Success() : FRes.Fail();
		}
		#endregion yWbNzZNVo^[^Ot](ZNV)


		#region yWbNzACeo^(L[AeARg)
		/// <summary>
		/// ACeo^(L[, e)
		/// </summary>
		/// <param name="strKey">L[</param>
		/// <param name="strContent">e</param>
		/// <param name="strComment">Rg</param>
		/// <returns>FRes or FRess</returns>
		public new FRes RegistItem(string strKey, string strContent, string strComment){
			// ACeo^
			return base.RegistItem(strKey, strContent, strComment);
		}
		#endregion yWbNzACeo^(L[, e)

		#region yWbNzRgACeo^
		/// <summary>
		/// yWbNzRgACeo^
		/// </summary>
		/// <param name="strComment">Rg</param>
		/// <returns>FRes or FRess</returns>
		public FRes RegistCommentItem(string strComment){
			// ACeo^
			return this.ActiveSection.RegistComment(strComment);
		}
		#endregion yWbNzRgACeo^

	}
	#endregion yNXzSioFileIniMi  ginit@CNX

}
